org.apache.http.entity

## Class HttpEntityWrapper

- java.lang.Object
- - org.apache.http.entity.HttpEntityWrapper

- All Implemented Interfaces:
    HttpEntity
  Direct Known Subclasses:
    BufferedHttpEntity, BufferingNHttpEntity, ConsumingNHttpEntityTemplate, NHttpEntityWrapper

      @NotThreadSafe
      public class HttpEntityWrapper
      extends Object
      implements HttpEntity

  Base class for wrapping entities. Keeps a `wrappedEntity` and delegates all calls to it. Implementations of wrapping entities can derive from this class and need to override only those methods that should not be delegated to the wrapped entity.
  Since:
    4.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected HttpEntity` | `wrappedEntity` The wrapped entity.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HttpEntityWrapper(HttpEntity wrappedEntity)` Creates a new entity wrapper.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `consumeContent()` Deprecated. (4.1) Either use `getContent()` and call `InputStream.close()` on that; otherwise call `writeTo(OutputStream)` which is required to free the resources.
    `InputStream` | `getContent()` Returns a content stream of the entity.
    `Header` | `getContentEncoding()` Obtains the Content-Encoding header, if known.
    `long` | `getContentLength()` Tells the length of the content, if known.
    `Header` | `getContentType()` Obtains the Content-Type header, if known.
    `boolean` | `isChunked()` Tells about chunked encoding for this entity.
    `boolean` | `isRepeatable()` Tells if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tells whether this entity depends on an underlying stream.
    `void` | `writeTo(OutputStream outstream)` Writes the entity content out to the output stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### wrappedEntity

          protected HttpEntity wrappedEntity

      The wrapped entity.

  - ### Constructor Detail

    - #### HttpEntityWrapper

          public HttpEntityWrapper(HttpEntity wrappedEntity)

      Creates a new entity wrapper.

  - ### Method Detail

    - #### isRepeatable

          public boolean isRepeatable()

      Description copied from interface: `HttpEntity`
      Tells if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.
      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### isChunked

          public boolean isChunked()

      Description copied from interface: `HttpEntity`
      Tells about chunked encoding for this entity. The primary purpose of this method is to indicate whether chunked encoding should be used when the entity is sent. For entities that are received, it can also indicate whether the entity was received with chunked encoding.
      The behavior of wrapping entities is implementation dependent, but should respect the primary purpose.
      Specified by:
        `isChunked` in interface `HttpEntity`
      Returns:
        `true` if chunked encoding is preferred for this entity, or `false` if it is not

    - #### getContentLength

          public long getContentLength()

      Description copied from interface: `HttpEntity`
      Tells the length of the content, if known.
      Specified by:
        `getContentLength` in interface `HttpEntity`
      Returns:
        the number of bytes of the content, or a negative number if unknown. If the content length is known but exceeds `Long.MAX_VALUE`, a negative number is returned.

    - #### getContentType

          public Header getContentType()

      Description copied from interface: `HttpEntity`
      Obtains the Content-Type header, if known. This is the header that should be used when sending the entity, or the one that was received with the entity. It can include a charset attribute.
      Specified by:
        `getContentType` in interface `HttpEntity`
      Returns:
        the Content-Type header for this entity, or `null` if the content type is unknown

    - #### getContentEncoding

          public Header getContentEncoding()

      Description copied from interface: `HttpEntity`
      Obtains the Content-Encoding header, if known. This is the header that should be used when sending the entity, or the one that was received with the entity. Wrapping entities that modify the content encoding should adjust this header accordingly.
      Specified by:
        `getContentEncoding` in interface `HttpEntity`
      Returns:
        the Content-Encoding header for this entity, or `null` if the content encoding is unknown

    - #### getContent

          public InputStream getContent()
                                 throws IOException

      Description copied from interface: `HttpEntity`
      Returns a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Specified by:
        `getContent` in interface `HttpEntity`
      Returns:
        content stream of the entity.
      Throws:
        `IOException` - if the stream could not be created
      See Also:
        `HttpEntity.isRepeatable()`

    - #### writeTo

          public void writeTo(OutputStream outstream)
                       throws IOException

      Description copied from interface: `HttpEntity`
      Writes the entity content out to the output stream.

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated when this method returns.

      Specified by:
        `writeTo` in interface `HttpEntity`
      Parameters:
        `outstream` - the output stream to write entity content to
      Throws:
        `IOException` - if an I/O error occurs

    - #### isStreaming

          public boolean isStreaming()

      Description copied from interface: `HttpEntity`
      Tells whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.
      Specified by:
        `isStreaming` in interface `HttpEntity`
      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### consumeContent

          @Deprecated
          public void consumeContent()
                              throws IOException

      Deprecated. (4.1) Either use `getContent()` and call `InputStream.close()` on that; otherwise call `writeTo(OutputStream)` which is required to free the resources.
      Description copied from interface: `HttpEntity`
      This method is deprecated since version 4.1. Please use standard java convention to ensure resource deallocation by calling `InputStream.close()` on the input stream returned by `HttpEntity.getContent()`

      This method is called to indicate that the content of this entity is no longer required. All entity implementations are expected to release all allocated resources as a result of this method invocation. Content streaming entities are also expected to dispose of the remaining content, if any. Wrapping entities should delegate this call to the wrapped entity.

      This method is of particular importance for entities being received from a `connection`. The entity needs to be consumed completely in order to re-use the connection with keep-alive.

      Specified by:
        `consumeContent` in interface `HttpEntity`
      Throws:
        `IOException` - if an I/O error occurs.
      See Also:
        `and #writeTo(OutputStream)`

Copyright © 2005–2013 The Apache Software Foundation. All rights reserved.